#!/usr/bin/perl
# edit_classes.cgi
# Manage the CUPS classes

require './cupsadmin-lib.pl';
&ReadParse(\%keys,'POST');

@values = keys(%keys) ;
@keys = values(%keys) ;
%sel ;
#since we pass the class name as the key, and the action as the 
#value, create the %sel hash reversing the key and value
while (@keys)
{
  $sel{$keys[0]} = $values[0] ;
  shift @keys ;
  shift @values ;
}
#we may have modified module_name from a previous error call,
#so just in case reset it
$module_name = $text{'cups_module'} ;

$cupsd_pid = &sched_running();
if ( -d $text{'cups_dir'} )
{
  $cups_installed = 'yes' ;
  if ( -r "$text{'cups_dir'}/$text{'cups_cconf'}" )
  {
    #note: we could use the lpstat/lpinfo commands to get most of this
    #info, however not all information is available from these commands
    #i.e. class acepting/rejecting jobs and start/stop class. So,
    #just get everything from the classes.conf file
  
    open (CLASS, "< $text{'cups_dir'}/$text{'cups_cconf'}") ;
    while (<CLASS>)
    {
      chomp ;
      if ( /^<Class / )
      {
        ($trash, $class) = split(' ', $_) ;
        chop $class ;
        push (@clist, $class) ;
      }
      elsif ( /^Info/ )
      {
        ($trash, $classes{$class}) = split (' ', $_, 2) ;
      }
      elsif ( /^Printer/ )
      {
        ($trash, $printer) = split (' ', $_, 2) ;
        if ( defined $printers{$class} )
        {
          $printers{$class} = "$printers{$class}\|$printer" ;
        }
        else
        {
          $printers{$class} = $printer ;
        }
      }
      elsif ( /^State / )
      {
        ($trash, $state{$class}) = split (' ', $_, 2) ;
      }
      elsif ( /^Accepting/ )
      {
        ($trash, $accept) = split (' ', $_, 2) ;
        if ( $accept eq 'No' )
        {
          $accept{$class} = $text{'cups_reject_job'} ;
        }
        elsif ( $accept eq 'Yes' )
        {
          $accept{$class} = $text{'cups_accept_job'} ;
        }
        else
        {
          $accept{$class} = '' ;
        }
      }
      elsif ( /^Location/ )
      {
        ($trash, $location{$class}) = split (' ', $_, 2) ;
      }
    }
    close CLASS ;
  }
  else
  {
    $cups_msg = $text{'cups_not_here'} ;
  }

}
else
{
  $cups_installed = 'no' ;
  $cups_msg = $text{'cups_not_here'} ;
  @clist = () ;
}
#get a list of all printers, regardless of class
my @output = `lpstat -p 2>/dev/null` ;
while (@output)
{
    ($trash, $printer) = split(' ', $output[0]) ;
    push (@all_printers, $printer) ;
    shift (@output) ;
}
# see if we need to perform any actions
if ( $sel{'Delete Class'} ) #then delete a class
{
  $cmd = "lpadmin -x $sel{'Delete Class'}" ;
  $out = &backquote_logged("$cmd 2>&1");
  if ($?) { $module_name = "$module_name/edit_classes.cgi" ; &error("lpadmin failed : <pre>$out ($cmd)</pre>"); }
  @trash = () ;
  @trash = @clist ; #go through the clist and delete the class from it
  @clist = () ;
  while (@trash)
  {
    if ($trash[0] ne $sel{'Delete Class'} )
    {
      push(@clist, $trash[0]) ;
    }
    shift (@trash) ;
  }
}
elsif ( $sel{'del_pclass'} ) #then delete printer(s) from a class
{
  @del_printers = split(/\0/, $sel{'cprinters'}) ;
  while (@del_printers)
  {
    if ( $del_printers[0] =~ $printers{$sel{'del_pclass'}} )
    {
      $cmd = "lpadmin -p $del_printers[0] -r $sel{'del_pclass'}" ;
      $out = &backquote_logged("$cmd 2>&1");
      if ($?) { $module_name = "$module_name/edit_classes.cgi" ; &error("lpadmin failed : <pre>$out ($cmd)</pre>"); }
    }
    shift (@del_printers) ;
  }
}
elsif ( $sel{'add_pclass'} ) #then add printer(s) to a class
{
  @add_printers = split(/\0/, $sel{'cprinters'}) ;
  while (@add_printers)
  {
    $cmd = "lpadmin -p $add_printers[0] -c $sel{'add_pclass'}" ;
    $out = &backquote_logged("$cmd 2>&1");
    if ($?) { $module_name = "$module_name/edit_classes.cgi" ; &error("lpadmin failed : <pre>$out ($cmd)</pre>"); }
    shift (@add_printers) ;
  }
}
elsif ( $sel{'make_class'} ) #then create a new class
{
  @add_printers = split(/\0/, $sel{'cprinters'}) ;
  if ( $#add_printers > -1 )
  {
    while (@add_printers)
    {
      #note:class name may only contain letters, numbers and underscore
      if ( $sel{'make_class'} =~ /[\000-\057]|[\072-\100]|[\133-\136]|[\173-\177]|\140/ )
      {
        $module_name = "$module_name/edit_classes.cgi" ;
        &error("<pre>$text{'cups_class_error'}\n$text{'cups_error_goback'}</pre>");
      }
      else
      {
        $cmd = "lpadmin -p $add_printers[0] -c $sel{'make_class'}" ;
        $out = &backquote_logged("$cmd 2>&1");
        if ($?) { $module_name = "$module_name/edit_classes.cgi" ; &error("lpadmin failed : <pre>$out ($cmd)</pre>"); }
      }
      shift (@add_printers) ;
    }
  }
  else
  {
    $module_name = "$module_name/edit_classes.cgi" ;
    &error("<pre>$text{'cups_error_no_printer'}\n$text{'cups_error_goback'}</pre>");
  }
}
elsif ( $sel{'Start Class'} ) #then start the printers in class
{
  $start_class = $sel{'Start Class'} ;
  $cmd = "enable $start_class" ;
  $out = &backquote_logged("$cmd 2>&1");
        if ($?) { $module_name = "$module_name/edit_classes.cgi" ; &error("enable failed : <pre>$out ($cmd)</pre>"); }
  $state{$start_class} = 'Idle' ;
}
elsif ( $sel{'Stop Class'} ) #then stop the printers in class
{
  $stop_class = $sel{'Stop Class'} ;
  $cmd = "disable -r Paused $stop_class" ;
  $out = &backquote_logged("$cmd 2>&1");
        if ($?) { $module_name = "$module_name/edit_classes.cgi" ; &error("disable failed : <pre>$out ($cmd)</pre>"); }
  $state{$stop_class} = 'Stopped' ;
}
elsif ( $sel{'Accept Jobs'} ) #then accept print jobs for a class
{
  $accept_class = $sel{'Accept Jobs'} ;
  $cmd = "accept $accept_class" ;
  $out = &backquote_logged("$cmd 2>&1");
        if ($?) { $module_name = "$module_name/edit_classes.cgi" ; &error("accept failed : <pre>$out ($cmd)</pre>"); }
  $accept{$accept_class} = $text{'cups_accept_job'} ;
}
elsif ( $sel{'Reject Jobs'} ) #then reject print jobs for a class
{
  $reject_class = $sel{'Reject Jobs'} ;
  $cmd = "reject $reject_class" ;
  $out = &backquote_logged("$cmd 2>&1");
        if ($?) { $module_name = "$module_name/edit_classes.cgi" ; &error("reject failed : <pre>$out ($cmd)</pre>"); }
  $accept{$reject_class} = 'rejecting jobs' ;
}

&header($text{'cups_classes'}, "");
print "<meta HTTP-EQUIV='Expires' CONTENT='now'>\n" ;
print "<meta HTTP-EQUIV='Pragma' CONTENT='no-cache'>\n" ; 

if (@clist)
{
  print "<table border width=100% >\n";
  print "<form method=post action=/cupsadmin/edit_classes.cgi>\n" ;
  for($i=0; $i<@clist; $i++) {
    print "<tr $tb><td><b>$text{'cups_class'}</b></td>\n";
    print "<td><b>$text{'index_desc'}</b></td>\n" ;
    print "<td><b>$text{'edit_location'}</b></td>\n" ;
    print "<td><b>$text{'cups_p_in_class'}</b></td>\n" ;
    print "<td><b>$text{'cups_class_state'}</b></td></tr>\n";
    print "<tr $tb><td>$clist[$i]</td>\n";
    if ( $classes{$clist[$i]} eq '' )
    {
      print "<td>&nbsp</td>\n";
    }
    else
    {
      print "<td>$classes{$clist[$i]}</td>\n";
    }
    if ( $location{$clist[$i]} eq '' )
    {
      print "<td>&nbsp</td>\n";
    }
    else
    {
      print "<td>$location{$clist[$i]}</td>\n";
    }
    @printers = split(/\|/, $printers{$clist[$i]}) ;
    print "<td><select size=1>\n" ;
    for ($j=0; $j<@printers; $j++)
    {
      print "<option>$printers[$j]\n" ;
    }
    print "</select></td>\n" ;
    print "<td>$state{$clist[$i]}, $accept{$clist[$i]}</td></tr>\n" ;
    print "<tr><td></td><td></td><td></td><td></td><td></td></tr>\n";
    print "<tr>\n" ;
    if ( $state{$clist[$i]} eq 'Stopped' )
    {
      print "<td bgcolor='#90EEEE' align=center><input type=submit name=$clist[$i] value=\"$text{'cups_start_class'}\"></td>\n";
    }
    else #we must be Idle or printing
    {
      print "<td bgcolor='#FF0000' align=center><input type=submit name=$clist[$i] value=\"$text{'cups_stop_class'}\"></td>\n";
    }
    if ( $accept{$clist[$i]} =~ /accepting/ )
    {
      print "<td bgcolor='#FF8C8C' align=center><input type=submit name=$clist[$i] value=\"$text{'cups_reject'}\"></td>\n";
    }
    else
    {
      print "<td bgcolor='#5F9E9E' align=center><input type=submit name=$clist[$i] value=\"$text{'cups_accept'}\"></td>\n";
    }
    print "<td bgcolor='#000000' align=center><input type=submit name=$clist[$i] value=\"$text{'cups_delete_class'}\"></td>" ;
    print "</form><form method=post action=/cupsadmin/modify_class.cgi>\n" ;
    print "<td align=center><input type=submit name=$clist[$i] value=\"$text{'cups_modify_class'}\"></td></form>\n";
    print "<form method=post action=/cupsadmin/edit_classes.cgi>\n" ;
    print "<td $cb>&nbsp&nbsp&nbsp&nbsp&nbsp</td></tr>" ;
    print "<tr><td></td><td></td><td></td><td></td><td></td></tr>\n";
    print "<tr><td></td><td></td><td></td><td></td><td></td></tr>\n";
    print "<tr><td></td><td></td><td></td><td></td><td></td></tr>\n";
    print "<tr><td></td><td></td><td></td><td></td><td></td></tr>\n";

  }
  print "</form></table>\n" ;
}
print "<hr>\n";
print "<table border width=100% >\n";
print "<form method=post action=/cupsadmin/new_class.cgi>\n" ;
print "<tr><td $cd align=center><input type=submit name=new_class value=\"$text{'cups_new_class'}\"></td>\n";
print "</form></table>\n" ;
print "<hr>\n";
       
&footer ('', $text{'index_return'});
