#!/usr/bin/perl
# modify_class.cgi
# Modify the CUPS class

require './cupsadmin-lib.pl';
&ReadParse(\%keys,'POST');

$mod = 'no' ;
@keys = keys(%keys) ;
@values = values(%keys) ;
%sel ;
while (@keys) 
{
  #the key and value are switched for the modify submit button
  #so switch them
  if ( $values[0] eq $text{'cups_modify_class'} )
  {
    $class = $keys[0] ;
    $keys[0] = $values[0] ;
    $values[0] = $class ;
  }
  if ( $values[0] eq $text{'cups_modify'} )
  {
    $class = $keys[0] ;
    $keys[0] = $values[0] ;
    $values[0] = $class ;
    $mod = 'yes' ;
  }
  
  $sel{$keys[0]} = $values[0] ;
  shift @keys ; 
  shift @values ;
}
#we may have modified module_name from a previous error call,
#so just in case reset it
$module_name = $text{'cups_module'} ;

#get a list of all printers, regardless of class
my @output = `lpstat -p 2>/dev/null` ;
while (@output)
{
    ($trash, $printer) = split(' ', $output[0]) ;
    push (@all_printers, $printer) ;
    shift (@output) ;
}

#get the list of printers for this class and store it in a hash
#for easy searching later
@output = () ;
@output = `lpstat -c $class 2>/dev/null` ;
chomp (@output) ;
while (@output)
{
  if ( $output[0] =~ /^members/ )
  {
    shift (@output) ;
    next ;  
  }
  $output[0] =~ s/\s+//g ;
  if ( $pclass{$class} eq '' )
  {
    $pclass{$class} = $output[0] ;
  }
  else
  {
    $pclass{$class} = "$pclass{$class}\|$output[0]" ;
  }
  shift (@output) ;
}

if ( -r "$text{'cups_dir'}/classes.conf" )
{
  open (CONF, "< $text{'cups_dir'}/classes.conf" ) ;
  while (<CONF>)
  {
    chomp ;
    if ( /^<Class $class>$/ )
    {
      while (<CONF>)
      {
        chomp ;
        if ( /^<\/Class>$/ )
        {
          last ;
        }
        
        if ( /^Location/ )
        {
          if ( $sel{'location'} eq '' and $mod eq 'no' )
          {
            ( $trash, $sel{'location'}) = split (' ', $_, 2) ;
          }
        }
        elsif ( /^Info/ )
        {
          if ( $sel{'desc'} eq '' and $mod eq 'no' )
          {
            ( $trash, $sel{'desc'}) = split (' ', $_, 2) ;
          }
        }
      }
    }
  }
  close (CONF) ;
}
else
{
  $module_name = "$module_name/modify_classes.cgi" ;
  &error("<pre>modify_failed.cgi could not open $text{'cups_dir'}/classes.conf</pre>");
}

#use the current description, if it exists
if ( $sel{'desc'} ne '' )
{
  $description = $sel{'desc'} ;
}
else
{
  $description = '' ;
}

#use the current location, if it exists
if ( $sel{'location'} )
{
  $location = $sel{'location'} ;
}
else
{
  $location = '' ;
}

if ( $sel{'cprinters'} ) #not first time loading this page
{
  $sel{'cprinters'} =~ s/\000/\|/g ;

  if ( $pclass{$class} ne $sel{'cprinters'} ) #our printers changed
  {
    @new_class = split (/\|/, $sel{'cprinters'}) ;
    $pclass{$class} = $sel{'cprinters'} ;
  }
  else
  {
    @new_class = split (/\|/, $pclass{$class}) ;
  }
}
if ( $mod eq 'yes' ) #then modify the classes.conf
{
  if ( -w "$text{'cups_dir'}/classes.conf" )
  {
    open (CONF, "< $text{'cups_dir'}/classes.conf" ) ;
    while (<CONF>)
    {
      chomp ;
      push (@old_conf, $_) ;
      if ( /^\<Class $class\>/ )
      {
        push (@new_conf, $_) ;
        if ( $description ne '' )
        {
            push (@new_conf, "Info $description") ;
        }
        if ( $location ne '' )
        {
            push (@new_conf, "Location $location") ;
        }
        while (<CONF>)
        {
          chomp ;
          if ( /^<\/Class\>/ )
          {
            push (@new_conf, $_) ;
            push (@old_conf, $_) ;
            while (<CONF>)
            {
              chomp ;
              push (@new_conf, $_) ;
              push (@old_conf, $_) ;
            }
          }
          elsif ( /^Info / )
          {
            push (@old_conf, $_) ;
          }
          elsif ( /^Location / )
          {
            push (@old_conf, $_) ;
          }
          elsif ( /^Printer / )
          {
            push (@old_conf, $_) ;
            while (@new_class)
            {
              push (@new_conf, "Printer $new_class[0]") ;
              shift (@new_class) ;
            }
            while (<CONF>)
            {
              chomp ;
              push (@old_conf, $_) ;
              if ( /^Printer / )
              {
                next ;
              }
              else
              {
                push (@new_conf, $_) ;
                last ;
              }
            }
          }
          else
          {
            push (@old_conf, $_) ;
            push (@new_conf, $_) ;
          }
        }
      }
      else
      {
        push (@new_conf, $_) ;
      }
    }
    close CONF ;
    &lock_file("$text{'cups_dir'}/classes.conf.O") ;
    open ( OLD, "> $text{'cups_dir'}/classes.conf.O" ) ;
    while (@old_conf)
    {
      print OLD "$old_conf[0]\n" ;
      shift (@old_conf) ;
    }
    close OLD ;
    &unlock_file("$text{'cups_dir'}/classes.conf.O") ;
    #we can lock the file for webmin use but, lpadmin doesn't lock it
    #so we take our chances
    &lock_file("$text{'cups_dir'}/classes.conf") ;
    open ( CONF, "> $text{'cups_dir'}/classes.conf" ) ;
    while (@new_conf)
    {
      print CONF "$new_conf[0]\n" ;
      shift (@new_conf) ;
    }
    close CONF ;
    &unlock_file("$text{'cups_dir'}/classes.conf") ;
  }
  else
  {
    $module_name = "$module_name/modify_classes.cgi" ;
    &error("<pre>modify_failed.cgi could not open $text{'cups_dir'}/classes.conf for writing</pre>");
  }
}
&header($text{'cups_modify_class'}, "");
print "<meta HTTP-EQUIV='Expires' CONTENT='now'>\n" ;
print "<meta HTTP-EQUIV='Pragma' CONTENT='no-cache'>\n" ; 

print "<table border width=100% >\n";
print "<form method=post action=/cupsadmin/modify_class.cgi>\n" ;
print "<tr $tb><td><b>$text{'cups_class'}</b></td>\n";
print "<td><b>$text{'index_desc'}</b></td>\n" ;
print "<td><b>$text{'edit_location'}</b></td>\n" ;
print "<td><b>$text{'cups_p_in_class'}</b></td>\n" ;
print "<tr $cb><td>$class</td>\n" ;
print "<td><input name=desc size=20 value=\"$description\"></td>" ;
print "<td><input name=location size=20 value=\"$location\"></td>" ;
print "<td><select name=cprinters size=3 multiple>\n" ;
for ($j=0; $j<@all_printers; $j++)
{
  if ( $all_printers[$j] =~ /^$pclass{$class}\| |
                            \|$pclass{$class}\| |
                            ^$pclass{$class}$   |
                            \|$pclass{$class}$/ )
  {
    $selected = 'selected' ;
  }
  else
  {
    $selected = '' ;
  }
  print "<option $selected value=$all_printers[$j]>$all_printers[$j]\n" ;
}
print "</select></td>\n" ;
print "<tr>\n" ;
print "<tr><td align=center><input type=submit name=$class value=\"$text{'cups_modify'}\"></td><td $cb></td><td $cb></td><td $cb></td></form>\n";
print "</form></table>\n" ;
print "<hr>\n";
       
&footer("/$text{'cups_module'}/edit_classes.cgi", $text{'cups_classes_return'});
