#!/usr/bin/perl
# new_class.cgi
# Add new CUPS class

require './cupsadmin-lib.pl';
&ReadParse(\%sel,'POST');

if ( $sel{'this_class'} and ! $sel{'clear'})
{
  $class = $sel{'this_class'} ;
  #class can only have numbers, letters and underscore
  if ( $class =~ /[\000-\057]|[\072-\100]|[\133-\136]|[\173-\177]|\140/ )
  {
    $module_name = "$module_name/new_class.cgi" ;
    &error("<pre>$text{'cups_class_error'}</pre>");
  }
  #reset module name just incase its been through the above if clause
  $module_name = $text{'cups_module'} ;
  $location = $sel{'location'} ;
  $description = $sel{'desc'} ; 
  @printers = split(/\000/, $sel{'cprinters'}) ;
  $sel{'cprinters'} =~ s/\000/\|/g ;
  $pclass{$class} = $sel{'cprinters'} ;
  while (@printers)
  {
    #let lpadmin create the class
    $cmd = "lpadmin -p $printers[0] -c $class" ;
    $out = &backquote_logged("$cmd 2>&1");
    if ($?) { $module_name = "$module_name/new_class.cgi" ; &error("lpadmin failed : <pre>$out ($cmd)</pre>"); }
    shift (@printers) ; 
  }

  #now add the Info and Location information, if we have it
  if ( -w "$text{'cups_dir'}/classes.conf" )
  {
    open (CONF, "< $text{'cups_dir'}/classes.conf" ) ;
    while (<CONF>)
    {
      chomp ;
      if ( /\<Class $class\>/ )
      {
        push (@conf, $_) ;
        if ( $description )
        {
          push (@conf, "Info $description") ;
        }
        if ( $location )
        {
          push (@conf, "Location $location") ;
        }
        next ;
      }
      push (@conf, $_) ;
    }
    close CONF ;
    &lock_file("$text{'cups_dir'}/classes.conf") ;
    open (CONF, "> $text{'cups_dir'}/classes.conf" ) ;
    while (@conf)
    {
      print CONF "$conf[0]\n" ;
      shift (@conf) ;
    }
    close CONF ;
    &unlock_file("$text{'cups_dir'}/classes.conf") ;
  }
}
else
{
  $class = '' ;
  $location = '' ;
  $description = '' ;
  @printers = () ;
}
#get a list of all printers, regardless of class
my @output = `lpstat -p 2>/dev/null` ;
while (@output)
{
    ($trash, $printer) = split(' ', $output[0]) ;
    push (@all_printers, $printer) ;
    shift (@output) ;
}

&header($text{'cups_create_class'}, "");
print "<meta HTTP-EQUIV='Expires' CONTENT='now'>\n" ;
print "<meta HTTP-EQUIV='Pragma' CONTENT='no-cache'>\n" ; 

print "<table border width=100% >\n";
print "<form method=post action=/cupsadmin/new_class.cgi>\n" ;
print "<tr $tb><td><b>$text{'cups_class'}</b></td>\n";
print "<td><b>$text{'index_desc'}</b></td>\n" ;
print "<td><b>$text{'edit_location'}</b></td>\n" ;
print "<td><b>$text{'cups_p_in_class'}</b></td></tr>\n" ;
print "<tr $cb><td><input name=this_class size=15 value=$class></td>\n" ;
print "<td><input name=desc size=15 value=\"$description\"></td>\n" ;
print "<td><input name=location size=15 value=\"$location\"></td>\n" ;
print "<td><select name=cprinters size=3 multiple>\n" ;
for ($j=0; $j<@all_printers; $j++)
{
  if ( $all_printers[$j] =~ /^$pclass{$class}\| |
                            \|$pclass{$class}\| |
                            ^$pclass{$class}$   |
                            \|$pclass{$class}$/ )
  {
    $selected = 'selected' ;
  }
  else
  {
    $selected = '' ;
  }
  print "<option $selected value=$all_printers[$j]>$all_printers[$j]\n" ;
}
print "</select></td>\n" ;
print "</table>\n" ;
print "<hr>\n";
print "<table border width=100% >\n";
print "<tr $cb><td align=center><input type=submit name=new value=\"$text{'cups_create_class'}\"></td>\n" ;
print "<td $cb align=center><input type=submit name=clear value='Clear all fields'></td></table></form>\n";
print "<hr>\n";
       
&footer("/$text{'cups_module'}/edit_classes.cgi", $text{'cups_classes_return'});
