#!/usr/bin/perl
# save_printer.cgi
# update a Created or modified printer

require './cupsadmin-lib.pl';
&ReadParse();
&Read_Conf() ;

# Check ACL
if ($in{'new'}) {
	$access{'add'} || &error($text{'save_eadd'});
	}
else {
	&can_edit_printer($in{'name'}) ||
		&error($text{'save_eedit'});
	}

%prn = %in ;

$prn{'default'} ? 'yes' : 'no' ;
if (&printer_support('allow')) {
	@ul = split(/\s+/, $in{'users'});
	if ($in{'access'} == 0) { $prn{'allow_all'}++; }
	elsif ($in{'access'} == 1) { $prn{'deny_all'}++; }
	else {
		$w = $in{'access'} == 2 ? "allow" : "deny";
		if (!@ul) { &error($text{"save_e$w"}); }
		foreach $u (@ul) {
			if ($u !~ /^\S+\!\S+$/ && !(@dummy=getpwnam($u))) {
				&error(&text('save_euser', $u));
				}
			}
		$prn{$w} = \@ul;
		}
	}
if (&printer_support('ctype')) {
	$prn{'banner'} = $in{'banner'};
	if ($in{'ctype_simple'}) { push(@ctype, "simple"); }
	if ($in{'ctype_postscript'}) { push(@ctype, "postscript"); }
	if ($in{'ctype_other'}) {
		push(@ctype, split(/\s+/, $in{'ctype_olist'}));
		}
	&error($text{'save_etype'}) if (!@ctype);
	$prn{'ctype'} = \@ctype;
	}
if (&printer_support('msize')) {
	if ($in{'msize_def'} == 2) {
		$prn{'msize'} = 0;
		}
	elsif ($in{'msize_def'} == 0) {
		$in{'msize'} =~ /^\d+$/ ||
			&error($text{'save_emax'});
		$prn{'msize'} = $in{'msize'};
		}
	}
 
if ( $prn{'cups_dev'} == 1 )
{
  if ( ! $prn{'ldev'} =~ /^$text{'cups_usb'}/ and
       ! $prn{'ldev'} =~ /^$text{'cups_serial'}/ and
       ! $prn{'ldev'} =~ /^$text{'cups_parallel'}/ )
  {
    &error($text{'cups_dev_error'});
  }
  ($trash, $device_number) = split(/#/, $prn{'ldev'}) ;
  $device_number-- ;
  if ( $prn{'ldev'} =~ /Parallel/ )
  {
    $prn{'device_number'}="$text{'cups_parallel_dev'}$device_number" ;
  }
  elsif ( $prn{'ldev'} =~ /^$text{'cups_usb'}/ )
  {
    $prn{'device_number'}="$text{'cups_usb_dev'}$device_number" ;
  }
  elsif ( $prn{'ldev'} =~ /^$text{'cups_serial'}/ )
  {
    $prn{'device_number'}="$text{'cups_serial_dev'}$device_number" ;
    if ( $prn{'cups_baud'} eq '' )
    {
      &error($text{'cups_baud_error'});
    }
    if ( $prn{'cups_parity'} eq '' )
    {
      &error($text{'cups_parity_error'});
    }
    if ( $prn{'cups_databits'} eq '' )
    {
      &error($text{'cups_datab_error'});
    }
    if ( $prn{'cups_flow'} eq '' )
    {
      &error($text{'cups_flow_error'});
    }
    else
    {
      if ( $prn{'cups_flow'} =~ /DTR/ )
      {
        $prn{'cups_flow'} = $text{'cups_flow_dtr'} ;
      }
      elsif ( $prn{'cups_flow'} =~ /RTS/ )
      {
        $prn{'cups_flow'} = $text{'cups_flow_hard'} ;
      }
      else
      {
        $prn{'cups_flow'} = $text{'cups_flow_soft'} ;
      }
    }
  }
}
elsif ( $prn{'cups_dev'} == 2 )
{
  if ( $prn{'cups_file'} eq '' )
  {
    &error($text{'cups_file_error'});
  }
}
elsif ( $prn{'cups_dev'} == 3 )
{
  if ( $prn{'cups_uri_dev'} eq '' )
  {
    &error($text{'cups_uri_device_error'});
  }
  if ( $prn{'cups_uri'} eq '' )
  {
    &error($text{'cups_uri_error'});
  }
}
else
{
    &error($text{'cups_dev_error'});
}
$prn{'cups_driver'} = $cups_drivers[$prn{'cups_driver'}] ;
if ( $prn{'cups_driver'} eq '' )
{
    &error($text{'cups_driver_error'});
}

#the user may have select more than one model, so filter the unwanted
#models out
@trash = split(/\($text{'cups_lang'}\)/, $prn{'cups_model'}) ;
while (@trash) #this works because the correct model will have the
               #driver name in it
{
  if ( $trash[0] =~ /$prn{'cups_driver'}/ )
  {
    $prn{'cups_model'} = $trash[0];
    chop $prn{'cups_model'} ; #remove the space that was before the (en)
  }
  shift (@trash) ;
}
if ( $prn{'cups_model'} eq '' )
{
    &error($text{'cups_model_error'});
}
else
{
  $model = $prn{'cups_model'} ;
  $model =~ s/\000//g ;
  $prn{'cups_model'} = $model ;
  $cups_path = `pwd` ;
  chomp ($cups_path) ;
  $prn{'cups_ppd'} = "$cups_path/ppd/$cups_models{$model}" ;
}
if ( $prn{'location'} eq '' )
{
    &error($text{'cups_location_error'});
}

# Create the printer
if ($in{'new'}) {
	&create_printer(\%prn);
	&webmin_log("create", "printer", $prn{'name'}, &log_info(\%prn));
	}
else {
	&modify_printer(\%prn);
	&webmin_log("modify", "printer", $prn{'name'}, &log_info(\%prn));
	}

# Update ACL
if ($in{'new'} && $access{'printers'} ne '*') {
	$access{'printers'} .= " ".$in{'name'};
	&save_module_acl(\%access);
	}
&redirect("");

sub connect_time_out
{
$connect_timed_out++;
}
